#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire1900one4xi.py">
#<abstract4xi abstract = "fires to direction one and to distance 1900"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire1900one4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "

       
# -------------------------------------------------------------------------------------------------
# SHOT2ONE - COORDINATE SIGNS OF SHOOT2ONE4XI: (X + ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------  

global shot2one19004xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings - copied from load2one4xi.py results to access faster by verb4xi.py
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False 


                         
# -------------------------------------------------------------------------------------------------
# 1900
# -------------------------------------------------------------------------------------------------                                          
shot2one19004xi = {
                  1:'0x0y1899z',
                  2:'0x1257y1423z',
                  3:'0x57y1899z',
                  4:'1002x676y1465z',
                  5:'1018x984y1265z',
                  6:'1027x1323y895z',
                  7:'102x136y1892z',
                  8:'1054x1174y1058z',
                  9:'1059x921y1279z',
                  10:'106x157y1890z',
                  11:'107x178y1888z',
                  12:'107x200y1886z',
                  13:'1089x1261y912z',
                  14:'1096x857y1293z',
                  15:'109x1576y1055z',
                  16:'109x234y1983z',
                  17:'10x15y1899z',
                  18:'1106x1110y1073z',
                  19:'1128x791y1307z',
                  20:'1147x1196y928z',
                  21:'1155x1043y1089z',
                  22:'1199x974y1105z',
                  23:'1201x1127y945z',
                  24:'1239x903y1120z',
                  25:'1251x1057y961z',
                  26:'125x1434y1239z',
                  27:'128x1222y1448z',
                  28:'1297x984y978z',
                  29:'148x1757y706z',
                  30:'174x1684y861z',
                  31:'18x207y1888z',
                  32:'190x1199y1461z',
                  33:'190x1557y1071z',
                  34:'198x1413y1253z',
                  35:'20x32y1899z',
                  36:'238x1740y723z',
                  37:'249x1173y1473z',
                  38:'260x1664y878z',
                  39:'269x1534y1086z',
                  40:'26x1590y1039z',
                  41:'270x1389y1267z',
                  42:'27x187y1890z',
                  43:'27x49y1899z',
                  44:'2x19y1899z',
                  45:'2x38y1899z',
                  46:'306x1144y1485z',
                  47:'328x1718y741z',
                  48:'339x1360y1282z',
                  49:'33x167y1892z',
                  50:'33x68y1898z',
                  51:'345x1639y895z',
                  52:'347x1508y1102z',
                  53:'361x1113y1496z',
                  54:'37x147y1893z',
                  55:'37x87y1897z',
                  56:'39x106y1896z',
                  57:'39x126y1895z',
                  58:'406x1328y1295z',
                  59:'414x1078y1508z',
                  60:'415x1691y758z',
                  61:'422x1477y1117z',
                  62:'428x1610y912z',
                  63:'463x1041y1519z',
                  64:'470x1293y1309z',
                  65:'495x1442y1133z',
                  66:'501x1660y776z',
                  67:'509x1577y928z',
                  68:'50x1451y1224z',
                  69:'510x1002y1531z',
                  70:'532x1254y1323z',
                  71:'554x960y1542z',
                  72:'566x1403y1148z',
                  73:'56x1769y688z',
                  74:'585x1624y793z',
                  75:'588x1539y945z',
                  76:'591x1213y1337z',
                  77:'595x917y1553z',
                  78:'59x46y1898z',
                  79:'633x872y1564z',
                  80:'634x1361y1163z',
                  81:'647x1168y1350z',
                  82:'65x1241y1436z',
                  83:'664x1498y961z',
                  84:'666x1583y810z',
                  85:'668x825y1574z',
                  86:'699x1316y1178z',
                  87:'700x778y1585z',
                  88:'701x1121y1363z',
                  89:'71x62y1897z',
                  90:'729x729y1595z',
                  91:'737x1452y977z',
                  92:'744x1539y827z',
                  93:'750x1072y1376z',
                  94:'754x679y1606z',
                  95:'760x1267y1193z',
                  96:'776x628y1616z',
                  97:'795x577y1626z',
                  98:'797x1020y1389z',
                  99:'807x1403y994z',
                  100:'819x1216y1207z',
                  101:'820x1491y844z',
                  102:'82x79y1896z',
                  103:'840x967y1402z',
                  104:'86x1699y844z',
                  105:'874x1162y1222z',
                  106:'874x1350y1010z',
                  107:'880x911y1415z',
                  108:'892x1438y861z',
                  109:'8x227y1886z',
                  110:'90x97y1895z',
                  111:'916x854y1428z',
                  112:'926x1105y1236z',
                  113:'937x1295y1026z',
                  114:'948x796y1440z',
                  115:'961x1383y878z',
                  116:'974x1046y1251z',
                  117:'977x736y1452z',
                  118:'97x116y1893z',
                  119:'997x1236y1042z'}
                 

#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire1900one4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire1900one4xi(queue2one, consumer_channel2one, publisher_channel2one):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE190ONE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE190ONE4XI -  QUEUE2ONE: ", queue2one)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE190ONE4XI -  CONSUMER_CHANNEL2ONE: ", consumer_channel2one)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE190ONE4XI -  PUBLISHER_CHANNEL2ONE: ", publisher_channel2one)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE190ONE4XI - TRYING TO RETURN BY PUTTING SHOT2ONE19004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2one.put(shot2one19004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE190ONE4XI - SUCCEEDED TO PUT SHOT2ONE19004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
            # SUCCEEDED TO PUT SHOT2ONE19004XI TO QUEUE2ONE:  <queue4xi.Queue4Xi object at 0x02AF7090>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE190ONE4XI *** FAILED TO PUT SHOT2ONE19004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE190ONE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi())
        #
         
    if ack2put is True:
        message2send4one = "<ack2put4xi>queue2one8shot2one19004xi</ack2put4xi>"
    else:
        message2send4one = "<nack2put4xi>queue2one8shot2one19004xi</nack2put4xi>" 
              
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
       
        publisher_channel2one.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE190ONE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
            # SENT MESSAGE2SEND4ONE:  <ack2put4xi>queue2one8shot2one19004xi</ack2put4xi>  TO PUBLISHER_CHANNEL2ONE:  <read-write PipeConnection, handle 260>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time
        
    except:
        print(" (STEP 3C/33) OF FIRE190ONE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE190ONE4XI - RETURNING QUEUE OBJECT QUEUE2ONE: ", queue2one, " - TIME: ", time4xi())  
        # 
            
    return queue2one    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire1900one4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
